import java.awt.Color;
import java.awt.Font;

import javax.swing.JTable;
import javax.swing.table.JTableHeader;


/**
 * Class MassLibTable implements a table which contains a information about the public
 * libraries in the state of Massachusetts.
 */
public class MassLibTable
  extends JTable
{
  //-----------------------------------------------------------------------
  // Constructors.
  //-----------------------------------------------------------------------

  /**
   * Creates an instance of this class.
   */
  public MassLibTable()
  {
    super(MassLibDatabase.getTableData(), MassLibDatabase.getColumnNames());
    
    configureTable();
    configureColumns();
  }  
 
  
  //-----------------------------------------------------------------------
  // Public methods.
  //-----------------------------------------------------------------------

  /**
   * Determines if the cell at the given location is editable.  Hardcoded to return false.
   */
  public boolean isCellEditable(int theRowIndex, int theColIndex)
  {
    return false;
  }
  

  //-----------------------------------------------------------------------
  // Private methods.
  //-----------------------------------------------------------------------
  
  /**
   * Configure this table's columns. 
   */
  private void configureColumns()
  {
    String[] theColNames = MassLibDatabase.getColumnNames();
  
    // Set the column widths.
    getColumn(theColNames[0]).setPreferredWidth(85);  // Region  
    getColumn(theColNames[1]).setPreferredWidth(155); // Municipality/Org. 
    getColumn(theColNames[2]).setPreferredWidth(200); // Library 
    getColumn(theColNames[3]).setPreferredWidth(155); // Address 1 
    getColumn(theColNames[4]).setPreferredWidth(95);  // Address 2 
    getColumn(theColNames[5]).setPreferredWidth(90);  // City 
    getColumn(theColNames[6]).setPreferredWidth(45);  // State 
    getColumn(theColNames[7]).setPreferredWidth(90);  // Zip
  }
  
  /**
   * Configure this table. 
   */
  private void configureTable()
  {
    JTableHeader theTableHeader = getTableHeader();
    Font         theFont = new Font("Sans Serif", Font.PLAIN, 12);
    
    // Configure the table.
    setFont(theFont);
    setBackground(new Color(222, 242, 255));
    setAutoResizeMode(AUTO_RESIZE_OFF);
    
    // Configure the table header.
    theTableHeader.setFont(theFont); 
  }
}